package cz.cvut.ok.kapo.paa.sat.objects;

/**
 * Tato trida obsahuje pouze globalni konstanty.
 * @author karel
 *
 */
public class EConstants {
	/** konstanta pro logger aplikace */
	public static final String APP_LOG = "cz.cvut.ok.kapo.paa.sat";
	
	//================ nastaveni enginu ============================
	
	/**
	 * Urcuje nastaveni pocatecni teploty. pomer prijatych ku
	 * celkovemu poctu generovanych stavu.
	 */
	public static double initialFraction = 0.7;
	
	/**
	 * Nad tuto uroven se pro hledani souseda
	 * pouzije okoli 3 tahu. (3 bity)
	 */
	public static double highFraction = 0.4;
	
	/**
	 * Nad tuto uroven se pro hledani souseda
	 * pouzije okoli 2 tahu. (2 bity)
	 */
	public static double mediumFraction = 0.25;
	
	/**
	 * Pro funkci cool(). Rychlost chlazeni: Tn = alpha*Tc
	 */
	public static double alpha = 0.9;
	
	/**
	 * Kolik je prijatych stavu k celkovemu, abychom to povazovali za
	 * zmrazeny.
	 */
	public static double frozen = 0.05;
	
	/**
	 * Pro funkci runParts(). Rychlost zvysovani poctu
	 * iteraci na jednu teplotu.
	 */
	public static double aIters = 1.005;
	
	/**
	 * Maximalni pocet iteraci - pocatecni.
	 */
	public static int maxIters = 500;
	
	/**
	 * Maximalni cas vypoctu. V [ms].
	 */
	public static long completeTimeout = 400000L;
	
	/**
	 * Perioda prekreslovani grafu. V [ms].
	 */
	public static long graphRepaintPeriod = 1000L;
	
	/**
	 * Perioda pridavani mezivysledku do grafu. V [ms].
	 */
	public static long graphFillPeriod = 700L;
}
