/**
 * 
 */
package cz.cvut.ok.kapo.paa.sat.objects;

import java.util.LinkedList;
import java.util.Vector;

/**
 * 
 * Tato trida obsahuje pouze staticke promenne, ktere jsou pristupne vsem balickum. 
 * Inicializuje je automaticky.
 * @author karel
 */
public class SharedVars {

	/**
	 * Synchronizacni zamek pro praci s poli
	 */
	public static Integer lock = new Integer(0);
	
	/**
	 * Vektor hodnot urcenych pro zobrazeni ve statistickem okne.
	 * Obsahuje pouze hodnoty pripustnych reseni.
	 */
	public static Vector<Integer> bestSolutionsStat = new Vector<Integer>();

	/**
	 * Vektor hodnot urcenych pro zobrazeni ve statistickem okne.
	 * Obsahuje nejlepsi prubezne vysledky i nepripustnych
	 * reseni.
	 */
	public static Vector<Integer> bestWorkingsStat = new Vector<Integer>();
	
	public static Vector<Integer> workingsStat = new Vector<Integer>();
	
	/**
	 * seznam stavu reprezentujicich nalezena pripustna reseni.
	 */
	public static LinkedList<State> solutions = new LinkedList<State>();

	/**
	 * seznam stavu reprezentujicich nalezene nejlepsi stavy
	 * i nepripustne.
	 */
	public static LinkedList<State> bestWorkings = new LinkedList<State>();
	
	//================= klonovaci metody pro praci s kolekcemi =================
	public static Vector<Integer> cloneSolutionsStat(){
		return new Vector<Integer>(SharedVars.bestSolutionsStat);
	}
	public static Vector<Integer> cloneBestWorkingsStat(){
		return new Vector<Integer>(SharedVars.bestWorkingsStat);
	}
	public static Vector<Integer> cloneWorkingsStat(){
		return new Vector<Integer>(SharedVars.workingsStat);
	}
	public static LinkedList<State> cloneBestWorkings(){
		return new LinkedList<State>(SharedVars.bestWorkings);
	}
	public static LinkedList<State> cloneBestSolutions(){
		return new LinkedList<State>(SharedVars.solutions);
	}
}
