package cz.cvut.ok.kapo.paa.sat.objects;

/**
 * Trida reprezenuje ohodnoceni jednotlivych promennych.<br>
 * Kazda promenna je identifikovana svym cislem. Cislovani promennych
 * je od 1..n.<br>
 * Trida obsahuje metody pro nastavovani/cteni hodnot promennych (true/false).
 * a mozna jeste i nejake dalsi :-)...
 * @author karel
 */
public class State implements Cloneable{
	private boolean[] variables;
	
	/**
	 * Inicializuje stav vsech promennych na false.
	 * @param varCount - pocet promennych
	 */
	public State(int varCount) {
		super();
		this.variables = new boolean[varCount];
		for (int i=0; i<this.variables.length;i++)
			this.variables[i] = false;
	}
	
// ============================== vytvareni instanci ================================
	/**
	 * Vrati Deep copy objektu.
	 */
	@Override
	public State clone(){
		State tmp = new State(this.variables.length);
		tmp.variables = this.variables.clone();
		return tmp;
	}

// ========================== pristupove metody ====================================
	/**
	 * Vrati hodnotu dane promenne.
	 * @param varNumber - cislo promenne
	 */
	public boolean getValue(int varNumber){
		return this.variables[varNumber-1];
	}
	
	/**
	 * Nastavi danou promennou na danou hodnotu
	 * @param varNumber - cislo promenne
	 * @param varValue - hodnota promenne
	 */
	public void setValue(int varNumber, boolean varValue){
		this.variables[varNumber-1] = varValue;
	}
	
	
	/**
	 * @return vraci pocet promennych.
	 */
	public int getVarsCount(){
		return this.variables.length;
	}
	
	/**
	 * Vrati string ve tvaru:
	 * [010001 ... 110111] reprezentujici stavy.
	 */
	@Override
	public String toString(){
		StringBuffer sb = new StringBuffer();
		sb.append("[");
		for (boolean var: this.variables)
			sb.append(var?1:0);
		sb.append("]");
		return sb.toString();
	}
	
}
