package cz.cvut.ok.kapo.paa.sat.objects;

/**
	 * Predstavuje trojici hodnot: cislo promenne, jeji vaha v teto klausuli
	 * a negace promenne (1 normal, -1 negovana).
 * @author karel
 *
 */
public class Variable implements Cloneable{
	private int varNum;
	private int varWeight;
	private boolean varNeg;
	/**
	 * @return Returns the varNeg.
	 */
	public boolean getVarNeg() {
		return this.varNeg;
	}
	/**
	 * @param varNeg The varNeg to set.
	 */
	public void setVarNeg(boolean varNeg) {
		this.varNeg = varNeg;
	}
	/**
	 * @return Returns the varNum.
	 */
	public int getVarNum() {
		return this.varNum;
	}
	/**
	 * @param varNum The varNum to set.
	 */
	public void setVarNum(int varNum) {
		this.varNum = varNum;
	}
	/**
	 * @return Returns the varWeight.
	 */
	public int getVarWeight() {
		return this.varWeight;
	}
	/**
	 * @param varWeight The varWeight to set.
	 */
	public void setVarWeight(int varWeight) {
		this.varWeight = varWeight;
	}
	
	/**
	 * Vrati skutecnou hodnotu promenne (bere v uvahu negaci).
	 * Podle nasledujici tabulky:
	 * val|neg|ret
	 * ---+---+---
	 *  0 | 0 | 0
	 *  0 | 1 | 1
	 *  1 | 0 | 1
	 *  1 | 1 | 0
	 * @param state odtud vytahne, zda je dana promenna true.
	 */
	public boolean getRealValue(State state){
		return state.getValue(getVarNum()) ^ getVarNeg();
	}
	
	@Override
	public Variable clone(){
		Variable tmp = new Variable();
		tmp.varNeg = this.varNeg;
		tmp.varNum = this.varNum;
		tmp.varWeight = this.varWeight;
		
		return tmp;
	}
	
	@Override
	public String toString(){
		StringBuffer sb = new StringBuffer();
		sb.append(" "+this.getVarWeight());
		sb.append("x"+this.getVarNum());
		if (this.getVarNeg())
			sb.append("'");
		return sb.toString();
	}
}
